﻿
using LibS7Adv;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using CommunityToolkit.Mvvm.ComponentModel;
using Newtonsoft.Json.Linq;
using CtrEditor.FuncionesBase;

namespace CtrEditor.ObjetosSim
{
    /// <summary>
    /// Interaction logic for ucBoolTag.xaml
    /// </summary>
    /// 

    public partial class osBoolTag : osBase, IosBase
    {

        // Otros datos y métodos relevantes para la simulación

        public static string NombreClase()
        {
            return "Bool Tag";
        }
        private string nombre = NombreClase();
        public override string Nombre
        {
            get => nombre;
            set => SetProperty(ref nombre, value);
        }

        [ObservableProperty]
        private Brush color_oculto;

        [ObservableProperty]
        Color color;

        [ObservableProperty]
        public bool estado;

        partial void OnEstadoChanged(bool value)
        {
            EscribirBitTag(Tag, value); 
            if (value)
                Color_oculto = Brushes.LightGreen;
            else
                Color_oculto = Brushes.Transparent;
        }
        
        [ObservableProperty]
        public float tamano;

        public override void OnResize(float Delta_Width, float Delta_Height)
        {
            Tamano += Delta_Width + Delta_Height;
        }

        [ObservableProperty]
        [NotifyPropertyChangedFor(nameof(Estado))]
        public string tag;

        [ObservableProperty]
        public string descripcion;     

        public osBoolTag()
        {
            Tamano = 0.30f;
            tag = "%M50.0";
            Descripcion = "Nombre del Tag";
            Color = Colors.LightBlue;
        }

        public override void UpdatePLCPrimerCiclo()
        {
            // Escribimos el valor actual al iniciar la conexion
            OnEstadoChanged(Estado);
        }

        public override void ucLoaded()
        {
            // El UserControl ya se ha cargado y podemos obtener las coordenadas para 
            // crear el objeto de simulacion
            base.ucLoaded();

        }
    }

    public partial class ucBoolTag : UserControl, IDataContainer
    {
        public osBase? Datos { get; set; }
        public int zIndex_fromFrames { get; set; }

        public ucBoolTag()
        {
            InitializeComponent();
            this.Loaded += OnLoaded;
            this.Unloaded += OnUnloaded;
        }
        private void OnLoaded(object sender, RoutedEventArgs e)
        {
            Datos?.ucLoaded();
        }
        private void OnUnloaded(object sender, RoutedEventArgs e)
        {
            Datos?.ucUnLoaded();
        }
        public void Highlight(bool State) { }
        public ZIndexEnum ZIndex_Base()
        {
            return ZIndexEnum.Estaticos;
        }

    }
}
